#RequireAdmin
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Change2CUI=y
#AutoIt3Wrapper_Res_Comment=RunInAnySession
#AutoIt3Wrapper_Res_Description=RunInAnySession
#AutoIt3Wrapper_Res_Fileversion=1.0.0.0
#AutoIt3Wrapper_Res_requestedExecutionLevel=asInvoker
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
; Much of the code is taken from wraithdu's examples
; Modified by Joakim
#include <WinAPI.au3>
Global Const $WTSActive = 0
Global Const $WTSShadow = 1
Global Const $WTSConnectQuery = 2
Global Const $tagWTS_SESSION_INFO = 'dword SessionId;ptr WinStationName;uint State'
Global $ProcArray[1][2]
Global $ghADVAPI32 = DllOpen("advapi32.dll")
Global Const $ERROR_INVALID_SID = 1337
Global Const $tagOBJECTATTRIBUTES = "ulong Length;hwnd RootDirectory;ptr ObjectName;ulong Attributes;ptr SecurityDescriptor;ptr SecurityQualityOfService"
Global Const $OBJ_CASE_INSENSITIVE = 0x00000040
Global Const $tagUNICODESTRING = "ushort Length;ushort MaximumLength;ptr Buffer"
$tagSTARTUPINFO1 = "dword cb;ptr lpReserved;ptr lpDesktop;ptr lpTitle;dword dwX;dword dwY;dword dwXSize;dword dwYSize;" & _
						"dword dwXCountChars;dword dwYCountChars;dword dwFillAttribute;dword dwFlags;ushort wShowWindow;" & _
						"ushort cbReserved2;ptr lpReserved2;ptr hStdInput;ptr hStdOutput;ptr hStdError"
$tagPROCESSINFO1 = "ptr hProcess;ptr hThread;dword dwProcessId;dword dwThreadId"
$NORMAL_PRIORITY_CLASS = 0x00000020
$CREATE_NEW_CONSOLE = 0x00000010
$CREATE_UNICODE_ENVIRONMENT = 0x00000400
If $cmdline[0] <> 4 Then
	ConsoleWrite("Wrong number of args supplied: " & $cmdline[0] & @CRLF)
	ConsoleWrite("Expected a path to a program" & @CRLF)
	ConsoleWrite(@CRLF)
	Exit
EndIf
$Privs = "SeDebugPrivilege,SeIncreaseQuotaPrivilege,SeTcbPrivilege";,SeAssignPrimaryTokenPrivilege"
$PrivsArray = StringSplit($Privs,",")
For $i = 1 To $PrivsArray[0]
	ConsoleWrite("Now setting privilege: " & $PrivsArray[$i] & @CRLF)
	_SetPrivilege($PrivsArray[$i])
Next
$Targets = "trustedinstaller.exe,services.exe,wininit.exe,lsass.exe,spoolsv.exe" ; We try to inject in this order
$TargetProcArray = StringSplit($Targets,",")
Global $sProcessAsUser = "services.exe"
Global $RunHidden = Int($cmdline[1])
Global $WantedSessionId = Int($cmdline[2])
Global $WantedAccount = $cmdline[3]
Global $sCmdLine = $cmdline[4]
Select
	Case $WantedAccount = "system"
		$Target = "Winlogon.exe"
	Case $WantedAccount = "user"
		$Target = "explorer.exe"
	Case Else
		ConsoleWrite("Error: Wrong input for WantedAccount: " & $WantedAccount & @CRLF)
EndSelect
If Not StringIsDigit($WantedSessionId) Then
	ConsoleWrite("Error: Wrong input for WantedSessionId: " & $WantedSessionId & @CRLF)
	Exit
EndIf

$Counter = 0
Local $aProcs = ProcessList($Target), $processPID = -1, $ret
If $WantedSessionId = 0 Then
	For $i = 1 To $aProcs[0][0]
		$ret = DllCall("kernel32.dll", "int", "ProcessIdToSessionId", "dword", $aProcs[$i][1], "dword*", 0)
		If Not @error And $ret[0] Then
			$processPID = $aProcs[$i][1]
			$ProcArray[$Counter][0] = $processPID
			$ProcArray[$Counter][1] = $ret[2]
			$Counter += 1
			Redim $ProcArray[$Counter+1][2]
		EndIf
	Next
Else
	For $i = 1 To $aProcs[0][0]
		$ret = DllCall("kernel32.dll", "int", "ProcessIdToSessionId", "dword", $aProcs[$i][1], "dword*", 0)
		If Not @error And $ret[0] And $ret[2]=$WantedSessionId Then
			$processPID = $aProcs[$i][1]
			$ProcArray[$Counter][0] = $processPID
			$ProcArray[$Counter][1] = $ret[2]
			$Counter += 1
			Redim $ProcArray[$Counter+1][2]
			ExitLoop ; In case several explorer instances are running in the same session
		EndIf
	Next
EndIf
For $i = 0 To UBound($ProcArray)-2
	ConsoleWrite("PID: " & $ProcArray[$i][0] & " SessionId: " & $ProcArray[$i][1] & @CRLF)
	$processPID = $ProcArray[$i][0]
	$TargetSessionId = $ProcArray[$i][1]
	If $processPID = -1 Then
		ConsoleWrite("Error: Process ID not found" & @CRLF)
		ContinueLoop
	EndIf

	Local $hProc = _NtOpenProcess($processPID)
	If @error Then
		ConsoleWrite("NtOpenProcess returned NtStatus: 0x" & Hex($hProc,8) & @CRLF)
		ContinueLoop
	Else
		$hProc = $hProc
	EndIf

	$hToken = DllCall($ghADVAPI32, "int", "OpenProcessToken", "ptr", $hProc, "dword", 0x000F01FF, "ptr*", 0)
	If @error Or Not $hToken[0] Then
		ConsoleWrite("OpenProcessToken: " & _WinAPI_GetLastErrorMessage() & @CRLF)
		DllCall("kernel32.dll", "int", "CloseHandle", "ptr", $hProc)
		ContinueLoop
	EndIf
	$hToken = $hToken[3]

	Local $hDupToken = DllCall($ghADVAPI32, "int", "DuplicateTokenEx", "ptr", $hToken, "dword", 0x1F0FFF, "ptr", 0, "int", 1, "int", 1, "ptr*", 0)
	If @error Or Not $hDupToken[0] Then
		ConsoleWrite("DuplicateTokenEx: " & _WinAPI_GetLastErrorMessage() & @CRLF)
		DllCall("kernel32.dll", "int", "CloseHandle", "ptr", $hToken)
		DllCall("kernel32.dll", "int", "CloseHandle", "ptr", $hProc)
		ContinueLoop
	EndIf
	$hDupToken = $hDupToken[6]
	Local $pEnvBlock
	$pEnvBlock = _GetEnvironmentBlock($sProcessAsUser, $TargetSessionId)

	Local $dwCreationFlags = BitOR($NORMAL_PRIORITY_CLASS, $CREATE_NEW_CONSOLE)
	If $pEnvBlock Then $dwCreationFlags = BitOR($dwCreationFlags, $CREATE_UNICODE_ENVIRONMENT)
	Local $SI = DllStructCreate($tagSTARTUPINFO1)
	DllStructSetData($SI, "cb", DllStructGetSize($SI))
	Local $PI = DllStructCreate($tagPROCESSINFO1)
	Local $sDesktop = "winsta0\default"
	Local $lpDesktop = DllStructCreate("wchar[" & StringLen($sDesktop) + 1 & "]")
	DllStructSetData($lpDesktop, 1, $sDesktop)
	DllStructSetData($SI, "lpDesktop", DllStructGetPtr($lpDesktop))
	If $RunHidden Then
		DllStructSetData($SI, "wShowWindow", 0)
		DllStructSetData($SI, "dwFlags", BitOR(0x00000001, 0x00000100))
		DllStructSetData($SI, "hStdOutput", 0)
	EndIf
	$ret = DllCall($ghADVAPI32, "int", "CreateProcessAsUserW", "ptr", $hDupToken, "ptr", 0, "wstr", $sCmdLine, "ptr", 0, "ptr", 0, "int", 0, "dword", $dwCreationFlags, "ptr", $pEnvBlock, "ptr", 0, "ptr", DllStructGetPtr($SI), "ptr", DllStructGetPtr($PI))
	If Not @error And $ret[0] Then
		ConsoleWrite("New process created successfully: " & DllStructGetData($PI, "dwProcessId") & @CRLF)
		DllCall("kernel32.dll", "int", "CloseHandle", "ptr", DllStructGetData($PI, "hThread"))
		DllCall("kernel32.dll", "int", "CloseHandle", "ptr", DllStructGetData($PI, "hProcess"))
	Else
		ConsoleWrite("CreateProcessAsUserW: " & _WinAPI_GetLastErrorMessage() & @CRLF)
	EndIf
	If $pEnvBlock Then DllCall("userenv.dll", "int", "DestroyEnvironmentBlock", "ptr", $pEnvBlock)
	DllCall("kernel32.dll", "int", "CloseHandle", "ptr", $hDupToken)
	DllCall("kernel32.dll", "int", "CloseHandle", "ptr", $hToken)
	DllCall("kernel32.dll", "int", "CloseHandle", "ptr", $hProc)

Next
Exit

Func _GetEnvironmentBlock($sProcess, $dwSession)
	Local Const $MAXIMUM_ALLOWED1 = 0x02000000
	Local Const $dwAccess = BitOR(0x2, 0x8) ; TOKEN_DUPLICATE | TOKEN_QUERY

	; get PID of process in current session
	Local $aProcs = ProcessList($sProcess), $processPID = -1, $ret = 0
	For $i = 1 To $aProcs[0][0]
		$ret = DllCall("kernel32.dll", "int", "ProcessIdToSessionId", "dword", $aProcs[$i][1], "dword*", 0)
		If Not @error And $ret[0] And ($ret[2] = $dwSession) Then
			$processPID = $aProcs[$i][1]
			ExitLoop
		EndIf
	Next
	If $processPID = -1 Then Return 0 ; failed to get PID
	; open process
	Local $hProc = DllCall("kernel32.dll", "ptr", "OpenProcess", "dword", $MAXIMUM_ALLOWED1, "int", 0, "dword", $processPID)
	If @error Or Not $hProc[0] Then Return 0
	$hProc = $hProc[0]
	; open process token
	$hToken = DllCall($ghADVAPI32, "int", "OpenProcessToken", "ptr", $hProc, "dword", $dwAccess, "ptr*", 0)
	If @error Or Not $hToken[0] Then
		DllCall("kernel32.dll", "int", "CloseHandle", "ptr", $hProc)
		Return 0
	EndIf
	$hToken = $hToken[3]
	; create a new environment block
	Local $pEnvBlock = DllCall("userenv.dll", "int", "CreateEnvironmentBlock", "ptr*", 0, "ptr", $hToken, "int", 1)
	If Not @error And $pEnvBlock[0] Then $ret = $pEnvBlock[1]
	; close handles
	DllCall("kernel32.dll", "int", "CloseHandle", "ptr", $hToken)
	DllCall("kernel32.dll", "int", "CloseHandle", "ptr", $hProc)
	Return $ret
EndFunc

Func _SetPrivilege($Privilege)
    Local $tagLUIDANDATTRIB = "int64 Luid;dword Attributes"
    Local $count = 1
    Local $tagTOKENPRIVILEGES = "dword PrivilegeCount;byte LUIDandATTRIB[" & $count * 12 & "]" ; count of LUID structs * sizeof LUID struct
    Local $TOKEN_ADJUST_PRIVILEGES = 0x20
    Local $SE_PRIVILEGE_ENABLED = 0x2

    Local $curProc = DllCall("kernel32.dll", "ptr", "GetCurrentProcess")
	Local $call = DllCall("advapi32.dll", "int", "OpenProcessToken", "ptr", $curProc[0], "dword", $TOKEN_ALL_ACCESS, "ptr*", "")
    If Not $call[0] Then Return False
    Local $hToken = $call[3]

    $call = DllCall("advapi32.dll", "int", "LookupPrivilegeValue", "str", "", "str", $Privilege, "int64*", "")
    Local $iLuid = $call[3]

    Local $TP = DllStructCreate($tagTOKENPRIVILEGES)
	Local $TPout = DllStructCreate($tagTOKENPRIVILEGES)
    Local $LUID = DllStructCreate($tagLUIDANDATTRIB, DllStructGetPtr($TP, "LUIDandATTRIB"))

    DllStructSetData($TP, "PrivilegeCount", $count)
    DllStructSetData($LUID, "Luid", $iLuid)
    DllStructSetData($LUID, "Attributes", $SE_PRIVILEGE_ENABLED)

    $call = DllCall("advapi32.dll", "int", "AdjustTokenPrivileges", "ptr", $hToken, "int", 0, "ptr", DllStructGetPtr($TP), "dword", DllStructGetSize($TPout), "ptr", DllStructGetPtr($TPout), "dword*", 0)
	$lasterror = _WinAPI_GetLastError()
	If $lasterror <> 0 Then
		ConsoleWrite("AdjustTokenPrivileges ("&$Privilege&"): " & _WinAPI_GetLastErrorMessage() & @CRLF)
		If $lasterror = 1300 Then
			$RightsAdder = _LsaAddAccountRights(@UserName, $Privilege)
			If not @error then
				ConsoleWrite("Reboot required for changes to take effect" & @CRLF)
			Else
				ConsoleWrite("Error: The right was probably not added correctly to your account" & @CRLF)
				Return SetError(1,0,0)
			EndIf
		EndIf
	EndIf
    DllCall("kernel32.dll", "int", "CloseHandle", "ptr", $hToken)
    Return ($call[0] <> 0) ; $call[0] <> 0 is success
EndFunc

Func _SetTokenInformation($hToken, $iTokenInformation, $vTokenInformation, $iTokenInformationLength)
	Local $aCall = DllCall("advapi32.dll", "bool", "SetTokenInformation", "handle", $hToken, "int", $iTokenInformation, "struct*", $vTokenInformation, "dword", $iTokenInformationLength)
	If @error Or Not $aCall[0] Then
		ConsoleWrite("SetTokenInformation: " & _WinAPI_GetLastErrorMessage() & @CRLF)
		Return SetError(1, @extended, False)
	EndIf
	Return True
EndFunc

Func _NtOpenProcess($PID)
    Local $sOA = DllStructCreate($tagOBJECTATTRIBUTES)
    DllStructSetData($sOA, "Length", DllStructGetSize($sOA))
    DllStructSetData($sOA, "RootDirectory", 0)
    DllStructSetData($sOA, "ObjectName", 0)
    DllStructSetData($sOA, "Attributes", $OBJ_CASE_INSENSITIVE)
    DllStructSetData($sOA, "SecurityDescriptor", 0)
    DllStructSetData($sOA, "SecurityQualityOfService", 0)

    Local $ClientID = DllStructCreate("dword_ptr UniqueProcessId;dword_ptr UniqueThreadId")
    DllStructSetData($ClientID, "UniqueProcessId", $PID)
    DllStructSetData($ClientID, "UniqueThreadId", 0)

    Local $aCall = DllCall("ntdll.dll", "hwnd", "NtOpenProcess", "handle*", 0, "dword", 0x001F0FFF, "struct*", $sOA, "struct*", $ClientID)
    If Not NT_SUCCESS($aCall[0]) Then
        ConsoleWrite("Error in NtOpenProcess: " & Hex($aCall[0], 8) & @CRLF)
        Return SetError(1, 0, $aCall[0])
    Else
        Return $aCall[1]
    EndIf
EndFunc

Func NT_SUCCESS($status)
    If 0 <= $status And $status <= 0x7FFFFFFF Then
        Return True
    Else
        Return False
    EndIf
EndFunc

Func _LsaAddAccountRights($sName, $sRight)
	Local $hPolicy, $tSid, $pSid, $iLength, $iSysError
	Local $tUnicode, $pUnicode, $iResult, $tRight, $pRight
	$tSid = _LookupAccountName($sName)
	$pSid = DllStructGetPtr($tSid)
	If Not _IsValidSid($pSid) Then Return SetError(@error, 0, 0)
	$hPolicy = _LsaOpenPolicy(0x811)
	$iLength = StringLen($sRight) * 2
	$tRight = DllStructCreate("wchar[" & $iLength & "]")
	$pRight = DllStructGetPtr($tRight)
	DllStructSetData($tRight, 1, $sRight)
	$tUnicode = DllStructCreate("ushort Length;ushort MemSize;ptr wBuffer")
	$pUnicode = DllStructGetPtr($tUnicode)
	DllStructSetData($tUnicode, "Length", $iLength)
	DllStructSetData($tUnicode, "MemSize", $iLength + 2)
	DllStructSetData($tUnicode, "wBuffer", $pRight)
	$iResult = DllCall("advapi32.dll", "dword", "LsaAddAccountRights", _
					"hWnd", $hPolicy, "ptr", $pSid, _
					"ptr", $pUnicode, "ulong", 1)
;	ConsoleWrite("LsaAddAccountRights Dec " & _LsaNtStatusToWinError($iResult[0]) & @CRLF)
	ConsoleWrite("LsaAddAccountRights 0x" & Hex(_LsaNtStatusToWinError($iResult[0]),8) & @CRLF)
	$tSid = 0
	_LsaClose($hPolicy)
	$iSysError = _LsaNtStatusToWinError($iResult[0])
	Return SetError($iSysError, 0, $iSysError = 0)
EndFunc

Func _LsaOpenPolicy($iAccess)
	Local $hPolicy, $tLsaAttr, $pLsaAttr
	$tLsaAttr = DllStructCreate("ulong;hWnd;ptr;ulong;ptr[2]")
	$pLsaAttr = DllStructGetPtr($tLsaAttr)
	$hPolicy = DllCall("advapi32.dll", "ulong", "LsaOpenPolicy", _
					"ptr", 0, "ptr", $pLsaAttr, "int", $iAccess, "hWnd*", 0)
	Return SetError(_LsaNtStatusToWinError($hPolicy[0]), 0, $hPolicy[4])
EndFunc

Func _LsaClose($hPolicy)
        Local $iResult
        $iResult = DllCall("advapi32.dll", "ulong", "LsaClose", "hWnd", $hPolicy)
        Return SetError(_LsaNtStatusToWinError($iResult[0]), 0, $iResult[0] = 0)
EndFunc

Func _LookupAccountName($sName, $sSystem = "")
        Local $iResult, $tSid, $pSid, $tDomain, $pDomain
        $iResult = DllCall("advapi32.dll", "int", "LookupAccountName", _
                        "str", $sSystem, "str", $sName, _
                        "ptr", 0, "int*", 0, "ptr", 0, "int*", 0, "int*", 0)
        If $iResult[4] = 0 Then Return SetError($ERROR_INVALID_SID, 0, 0)
        $tSid = DllStructCreate("ubyte[" & $iResult[4] & "]")
        $tDomain = DllStructCreate("ubyte[" & $iResult[6] & "]")
        $pSid = DllStructGetPtr($tSid)
        $pDomain = DllStructGetPtr($tDomain)
        $iResult = DllCall("advapi32.dll", "int", "LookupAccountName", _
                        "str", $sSystem ,"str", $sName, _
                        "ptr", $pSid, "int*", $iResult[4], _
                        "ptr", $pDomain, "int*", $iResult[6], "int*", 0)
        Return SetError(Not $iResult[0], $iResult[7], $tSid)
EndFunc

Func _IsValidSid($pSid)
        Local $iResult
        $iResult = DllCall("advapi32.dll", "int", "IsValidSid", "ptr", $pSid)
        If $iResult[0] Then Return SetError(0, 0, True)
        Return SetError($ERROR_INVALID_SID, 0, 0)
EndFunc

Func _LsaNtStatusToWinError($iNtStatus)
	Local $iSysError
	$iSysError = DllCall("Advapi32.dll", "ulong", "LsaNtStatusToWinError", "dword", $iNtStatus)
	Return $iSysError[0]
EndFunc

Func _WTSEnumerateSessionsW($hServer)
	Local $SessionCounter
	Local $Ret = DllCall('wtsapi32.dll', 'bool', 'WTSEnumerateSessionsW', 'ptr', $hServer, 'dword', 0, 'dword', 1, 'ptr*', 0, 'dword*', 0)
	If @error or not $Ret[0] Then
		Return SetError(1,0,0)
	Else
		$Offset = 0
		For $i = 1 To $Ret[5]
			$tInfo = DllStructCreate($tagWTS_SESSION_INFO, $Ret[4] + $Offset)
			$Offset += DllStructGetSize($tInfo)
			$SessionId = DllStructGetData($tInfo, 'SessionId')
			$SessionName = DllStructGetData(DllStructCreate('wchar[1024]', DllStructGetData($tInfo, 'WinStationName')), 1)
			$SessionState = DllStructGetData($tInfo, 'State')
			If $SessionState = $WTSActive Or $SessionState = $WTSShadow Or $SessionState = $WTSConnectQuery Then
				ConsoleWrite("$SessionId: " & $SessionId & @CRLF)
				ConsoleWrite("$SessionName: " & $SessionName & @CRLF)
				ConsoleWrite("$SessionState: " & $SessionState & @CRLF)
				$SessionCounter &= $SessionId&","
			EndIf
		Next
	EndIf
	Return StringTrimRight($SessionCounter,1)
EndFunc